$SAFE = 2
$CUR = '%0.2f'

# ***** Code Fixes *****
# Overrides some methods in the base class String.
class String
	alias orig_to_f to_f
	alias orig_to_i to_i
	alias string_format %
	def to_f
		delete(',').orig_to_f
	end
	def to_i
		delete(',').orig_to_i
	end
	def %(arg)
		if (arg.kind_of?(Array) or index('f') == nil)
			string_format(arg)
		else
			value = arg.to_f
			string_format(value < 0.0 ? value - 0.00000001 : value + 0.00000001)
		end
	end

end

# ***** Profile Classes *****
class Individual
 def first_name; ''; end
 def middle_initial; ''; end
 def last_name; ''; end
 def suffix; ''; end
 def address; ''; end
 def apartment_number; ''; end
 def city; ''; end
 def state; ''; end
 def zip; ''; end
 def phone; ''; end
 def work_phone; ''; end
 def mobile_phone; ''; end
 def fax; ''; end
 def ssn; ''; end
 def occupation; ''; end
 def county; ''; end
 def school_code; ''; end
 def email; ''; end
 def blind; ''; end
 def sixty_five_plus; ''; end
 def spouse_first_name; ''; end
 def spouse_middle_initial; ''; end
 def spouse_last_name; ''; end
 def spouse_suffix; ''; end
 def spouse_address; ''; end
 def spouse_apartment_number; ''; end
 def spouse_city; ''; end
 def spouse_state; ''; end
 def spouse_zip; ''; end
 def spouse_phone; ''; end
 def spouse_work_phone; ''; end
 def spouse_mobile_phone; ''; end
 def spouse_fax; ''; end
 def spouse_ssn; ''; end
 def spouse_occupation; ''; end
 def spouse_county; ''; end
 def spouse_school_code; ''; end
 def spouse_email; ''; end
 def spouse_blind; ''; end
 def spouse_65_plus; ''; end
 def single; ''; end
 def married_joint; ''; end
 def married_separate; ''; end
 def head_of_household; ''; end
 def widow_widower; ''; end
 def direct_deposit_checking; ''; end
 def direct_deposit_savings; ''; end
 def routing_number; ''; end
 def account_number; ''; end
 def dependent1_first_name; ''; end
 def dependent1_last_name; ''; end
 def dependent1_ssn; ''; end
 def dependent1_relationship; ''; end
 def dependent1_dob; ''; end
 def dependent2_first_name; ''; end
 def dependent2_last_name; ''; end
 def dependent2_ssn; ''; end
 def dependent2_relationship; ''; end
 def dependent2_dob; ''; end
 def dependent3_first_name; ''; end
 def dependent3_last_name; ''; end
 def dependent3_ssn; ''; end
 def dependent3_relationship; ''; end
 def dependent3_dob; ''; end
 def dependent4_first_name; ''; end
 def dependent4_last_name; ''; end
 def dependent4_ssn; ''; end
 def dependent4_relationship; ''; end
 def dependent4_dob; ''; end
 def dependent5_first_name; ''; end
 def dependent5_last_name; ''; end
 def dependent5_ssn; ''; end
 def dependent5_relationship; ''; end
 def dependent5_dob; ''; end
 def dependent6_first_name; ''; end
 def dependent6_last_name; ''; end
 def dependent6_ssn; ''; end
 def dependent6_relationship; ''; end
 def dependent6_dob; ''; end
 def business_name; ''; end
 def business_address; ''; end
 def business_address2; ''; end
 def business_city; ''; end
 def business_state; ''; end
 def business_zip; ''; end
 def fein; ''; end
 def business_phone; ''; end
 def business_fax; ''; end
 def business_email; ''; end
end

class Preparer
 def first_name; ''; end
 def middle_initial; ''; end
 def last_name; ''; end
 def firm_name; ''; end
 def address; ''; end
 def city; ''; end
 def state; ''; end
 def zip; ''; end
 def phone; ''; end
 def work_phone; ''; end
 def mobile_phone; ''; end
 def fax; ''; end
 def email; ''; end
 def fein; ''; end
 def ptin; ''; end
 def ssn; ''; end
 def self_employed; ''; end
end

class Entity
 def name; ''; end
 def address; ''; end
 def address2; ''; end
 def city; ''; end
 def state; ''; end
 def zip; ''; end
 def phone; ''; end
 def fax; ''; end
 def email; ''; end
 def fein; ''; end
 def state_id; ''; end
 def date_started; ''; end
 def state_of_incorporation; ''; end
 def naics_code; ''; end
 def principal_activity; ''; end
 def contact_name; ''; end
 def contact_title; ''; end
 def contact_phone; ''; end
 def estate_name; ''; end
 def estate_ssn; ''; end
 def estate_dod; ''; end
 def agent_first_name; ''; end
 def agent_middle_initial; ''; end
 def agent_last_name; ''; end
 def agent_business_name; ''; end
 def agent_address; ''; end
 def agent_city; ''; end
 def agent_state; ''; end
 def agent_zip; ''; end
 def agent_phone; ''; end
end

class Fiduciary
 def first_name_and_mi; ''; end
 def last_name; ''; end
 def title; ''; end
 def address; ''; end
 def city; ''; end
 def state; ''; end
 def zip; ''; end
 def phone; ''; end
 def ssn; ''; end
 def estate_name; ''; end
 def ein; ''; end
 def entity_creation_date; ''; end
 def entity_type_decendents; ''; end
 def entity_type_simple; ''; end
 def entity_type_complex; ''; end
 def entity_type_disability; ''; end
 def entity_type_esbt; ''; end
 def entity_type_grantor; ''; end
 def entity_type_bankruptcy_ch7; ''; end
 def entity_type_bankruptcy_ch11; ''; end
 def entity_type_pooled_income; ''; end
 def decedent_first_name_and_mi; ''; end
 def decedent_last_name; ''; end
 def decedent_address; ''; end
 def decedent_city; ''; end
 def decedent_state; ''; end
 def decedent_zip; ''; end
 def decedent_phone; ''; end
 def decedent_ssn; ''; end
 def decedent_dob; ''; end
 def decedent_dod; ''; end
end

class Equifax
def account_name; ''; end
def unemp_tax_yes; ''; end
def unemp_tax_no; ''; end
def local_wh_tax_yes; ''; end
def local_wh_tax_no; ''; end
def wh_tax_yes; ''; end
def wh_tax_no; ''; end
def emp_tax_consult_yes; ''; end
def emp_tax_consult_no; ''; end
def open_new_business; ''; end
def exist_entity_new_in_state; ''; end
def acquire_exist_business; ''; end
def reopen_inactiv_business; ''; end
def change_owner_type_entity; ''; end
def name_change; ''; end
def acct_closures; ''; end
def other_checkbox; ''; end
def other_list; ''; end
def succ_business_name; ''; end
def succ_trade_dba; ''; end
def succ_fein; ''; end
def succ_phone; ''; end
def succ_corp_address; ''; end
def succ_corp_address2; ''; end
def succ_corp_city; ''; end
def succ_corp_state; ''; end
def succ_corp_zip; ''; end
def succ_mailing_address; ''; end
def succ_mailing_address2; ''; end
def succ_mailing_city; ''; end
def succ_mailing_state; ''; end
def succ_mailing_zip; ''; end
def succ_contact_name; ''; end
def succ_contact_title; ''; end
def succ_contact_phone; ''; end
def succ_contact_fax; ''; end
def succ_contact_email; ''; end
def succ_entity_type_corp_public; ''; end
def succ_entity_type_corp_private; ''; end
def succ_entity_type_partnership; ''; end
def succ_entity_type_ltd_partnership; ''; end
def succ_entity_type_scorp; ''; end
def succ_entity_type_other_checkbox; ''; end
def succ_entity_type_other_list; ''; end
def succ_entity_type_llc; ''; end
def succ_entity_type_taxed_as_corp; ''; end
def succ_entity_type_taxed_as_partnership; ''; end
def succ_entity_type_disregarded_entity; ''; end
def succ_entity_type_disregarded_entity_member_name; ''; end
def succ_entity_type_disregarded_entity_member_fein; ''; end
def succ_entity_type_sole_proprietor; ''; end
def succ_state_of_incorporation; ''; end
def succ_date_started; ''; end
def succ_fiscal_yr_end_date; ''; end
def succ_acctng_method_cash; ''; end
def succ_acctng_method_accrual; ''; end
def succ_first_day_of_employment; ''; end
def succ_first_payroll_date; ''; end
def succ_nature_of_business_retail; ''; end
def succ_nature_of_business_wholesale; ''; end
def succ_nature_of_business_manufacturing; ''; end
def succ_nature_of_business_service; ''; end
def succ_nature_of_business_staffing_temp; ''; end
def succ_nature_of_business_prof_emp_org; ''; end
def succ_nature_of_business_other_checkbox; ''; end
def succ_nature_of_business_other_list; ''; end
def succ_business_activity_description; ''; end
def succ_naics_code; ''; end
def succ_501_c_3_exempt_yes; ''; end
def succ_501_c_3_exempt_no; ''; end
def succ_futa_yes; ''; end
def succ_futa_no; ''; end
def succ_futa_date_first_liability; ''; end
def succ_psp_na; ''; end
def succ_psp_name; ''; end
def succ_psp_contact_name; ''; end
def succ_psp_phone; ''; end
def succ_psp_address; ''; end
def succ_psp_city; ''; end
def succ_psp_state; ''; end
def succ_psp_zip; ''; end
def succ_bank_name; ''; end
def succ_bank_address; ''; end
def succ_bank_city; ''; end
def succ_bank_state; ''; end
def succ_bank_zip; ''; end
def succ_bank_phone; ''; end
def succ_bank_acct_number; ''; end
def succ_empl_other_states_yes; ''; end
def succ_empl_other_states_no; ''; end
def succ_empl_other_states_multiple; ''; end
def succ_break_in_employment_yes; ''; end
def succ_break_in_employment_no; ''; end
def succ_total_payroll_quarter; ''; end
def succ_total_payroll_year; ''; end
def succ_20th_wk_date_emp; ''; end
def succ_parent_company_name; ''; end
def succ_parent_company_fein; ''; end
def succ_officer1_name; ''; end
def succ_officer1_title; ''; end
def succ_officer1_ssn_ein; ''; end
def succ_officer1_address; ''; end
def succ_officer1_city; ''; end
def succ_officer1_state; ''; end
def succ_officer1_zip; ''; end
def succ_officer1_dob; ''; end
def succ_officer1_date_of_appt; ''; end
def succ_officer2_name; ''; end
def succ_officer2_title; ''; end
def succ_officer2_ssn_ein; ''; end
def succ_officer2_address; ''; end
def succ_officer2_city; ''; end
def succ_officer2_state; ''; end
def succ_officer2_zip; ''; end
def succ_officer2_dob; ''; end
def succ_officer2_date_of_appt; ''; end
def succ_officer3_name; ''; end
def succ_officer3_title; ''; end
def succ_officer3_ssn_ein; ''; end
def succ_officer3_address; ''; end
def succ_officer3_city; ''; end
def succ_officer3_state; ''; end
def succ_officer3_zip; ''; end
def succ_officer3_dob; ''; end
def succ_officer3_date_of_appt; ''; end
def pred_name; ''; end
def pred_dba; ''; end
def pred_fein; ''; end
def pred_phone; ''; end
def pred_corp_address; ''; end
def pred_corp_address2; ''; end
def pred_corp_city; ''; end
def pred_corp_state; ''; end
def pred_corp_zip; ''; end
def pred_contact_name; ''; end
def pred_contact_phone; ''; end
def pred_contact_mailing_address; ''; end
def pred_contact_mailing_address2; ''; end
def pred_contact_mailing_city; ''; end
def pred_contact_mailing_state; ''; end
def pred_contact_mailing_zip; ''; end
def pred_transaction_date; ''; end
def pred_operating_at_time_of_purchase_yes; ''; end
def pred_operating_at_time_of_purchase_no; ''; end
def pred_transaction_type_asset_purchase; ''; end
def pred_transaction_type_stock_purchase; ''; end
def pred_transaction_type_company_reorg; ''; end
def pred_transaction_type_salutory_merger; ''; end
def pred_transaction_type_other_checkbox; ''; end
def pred_transaction_type_other_list; ''; end
def pred_transaction_type_employee_reassignment; ''; end
def pred_transaction_type_bankruptcy_acq; ''; end
def pred_transaction_type_entity_conversion; ''; end
def pred_acq_all_employment; ''; end
def pred_acq_partial_employment; ''; end
def pred_emp_agency_yes; ''; end
def pred_emp_agency_no; ''; end
def pred_business_description; ''; end
def pred_succ_commonly_owned_yes; ''; end
def pred_succ_commonly_owned_no; ''; end
def pred_succ_commonly_owned_percent; ''; end
def pred_succ_relationship_described; ''; end
def pred_acquired_assets_acct_rec; ''; end
def pred_acquired_assets_machinery_equip; ''; end
def pred_acquired_assets_furniture_fixtures; ''; end
def pred_acquired_assets_goodwill; ''; end
def pred_acquired_assets_buildings; ''; end
def pred_acquired_assets_stock; ''; end
def pred_acquired_assets_other_real_prop_leases; ''; end
def pred_acquired_assets_customer_lists; ''; end
def pred_acquired_assets_employees; ''; end
def pred_acquired_assets_inventories; ''; end
def pred_will_report_wages_yes; ''; end
def pred_will_report_wages_no; ''; end
def pred_last_date_of_emp; ''; end
def pred_date_of_last_payroll; ''; end
def pred_parent_company_name; ''; end
def pred_parent_company_fein; ''; end
def pred_officer1_name; ''; end
def pred_officer1_title; ''; end
def pred_officer1_ssn_ein; ''; end
def pred_officer1_address; ''; end
def pred_officer1_city; ''; end
def pred_officer1_state; ''; end
def pred_officer1_zip; ''; end
def pred_officer1_dob; ''; end
def pred_officer1_date_of_appt; ''; end
def pred_officer2_name; ''; end
def pred_officer2_title; ''; end
def pred_officer2_ssn_ein; ''; end
def pred_officer2_address; ''; end
def pred_officer2_city; ''; end
def pred_officer2_state; ''; end
def pred_officer2_zip; ''; end
def pred_officer2_dob; ''; end
def pred_officer2_date_of_appt; ''; end
def pred_officer3_name; ''; end
def pred_officer3_title; ''; end
def pred_officer3_ssn_ein; ''; end
def pred_officer3_address; ''; end
def pred_officer3_city; ''; end
def pred_officer3_state; ''; end
def pred_officer3_zip; ''; end
def pred_officer3_dob; ''; end
def pred_officer3_date_of_appt; ''; end
def AK_pred_unemp_acct_number; ''; end
def AK_succ_unemp_acct_number; ''; end
def AK_pred_wh_acct_number; ''; end
def AK_address1; ''; end
def AK_city; ''; end
def AK_zip; ''; end
def AK_number_emp_transferred; ''; end
def AK_number_emp_retained; ''; end
def AK_est_mo_wages; ''; end
def AK_est_state_wh_tax; ''; end
def AL_pred_unemp_acct_number; ''; end
def AL_succ_unemp_acct_number; ''; end
def AL_pred_wh_acct_number; ''; end
def AL_address1; ''; end
def AL_city; ''; end
def AL_zip; ''; end
def AL_number_emp_transferred; ''; end
def AL_number_emp_retained; ''; end
def AL_est_mo_wages; ''; end
def AL_est_state_wh_tax; ''; end
def AR_pred_unemp_acct_number; ''; end
def AR_succ_unemp_acct_number; ''; end
def AR_pred_wh_acct_number; ''; end
def AR_address1; ''; end
def AR_city; ''; end
def AR_zip; ''; end
def AR_number_emp_transferred; ''; end
def AR_number_emp_retained; ''; end
def AR_est_mo_wages; ''; end
def AR_est_state_wh_tax; ''; end
def AZ_pred_unemp_acct_number; ''; end
def AZ_succ_unemp_acct_number; ''; end
def AZ_pred_wh_acct_number; ''; end
def AZ_address1; ''; end
def AZ_city; ''; end
def AZ_zip; ''; end
def AZ_number_emp_transferred; ''; end
def AZ_number_emp_retained; ''; end
def AZ_est_mo_wages; ''; end
def AZ_est_state_wh_tax; ''; end
def CA_pred_unemp_acct_number; ''; end
def CA_succ_unemp_acct_number; ''; end
def CA_pred_wh_acct_number; ''; end
def CA_address1; ''; end
def CA_city; ''; end
def CA_zip; ''; end
def CA_number_emp_transferred; ''; end
def CA_number_emp_retained; ''; end
def CA_est_mo_wages; ''; end
def CA_est_state_wh_tax; ''; end
def CO_pred_unemp_acct_number; ''; end
def CO_succ_unemp_acct_number; ''; end
def CO_pred_wh_acct_number; ''; end
def CO_address1; ''; end
def CO_city; ''; end
def CO_zip; ''; end
def CO_number_emp_transferred; ''; end
def CO_number_emp_retained; ''; end
def CO_est_mo_wages; ''; end
def CO_est_state_wh_tax; ''; end
def CT_pred_unemp_acct_number; ''; end
def CT_succ_unemp_acct_number; ''; end
def CT_pred_wh_acct_number; ''; end
def CT_address1; ''; end
def CT_city; ''; end
def CT_zip; ''; end
def CT_number_emp_transferred; ''; end
def CT_number_emp_retained; ''; end
def CT_est_mo_wages; ''; end
def CT_est_state_wh_tax; ''; end
def DC_pred_unemp_acct_number; ''; end
def DC_succ_unemp_acct_number; ''; end
def DC_pred_wh_acct_number; ''; end
def DC_address1; ''; end
def DC_city; ''; end
def DC_zip; ''; end
def DC_number_emp_transferred; ''; end
def DC_number_emp_retained; ''; end
def DC_est_mo_wages; ''; end
def DC_est_state_wh_tax; ''; end
def DE_pred_unemp_acct_number; ''; end
def DE_succ_unemp_acct_number; ''; end
def DE_pred_wh_acct_number; ''; end
def DE_address1; ''; end
def DE_city; ''; end
def DE_zip; ''; end
def DE_number_emp_transferred; ''; end
def DE_number_emp_retained; ''; end
def DE_est_mo_wages; ''; end
def DE_est_state_wh_tax; ''; end
def FL_pred_unemp_acct_number; ''; end
def FL_succ_unemp_acct_number; ''; end
def FL_pred_wh_acct_number; ''; end
def FL_address1; ''; end
def FL_city; ''; end
def FL_zip; ''; end
def FL_number_emp_transferred; ''; end
def FL_number_emp_retained; ''; end
def FL_est_mo_wages; ''; end
def FL_est_state_wh_tax; ''; end
def GA_pred_unemp_acct_number; ''; end
def GA_succ_unemp_acct_number; ''; end
def GA_pred_wh_acct_number; ''; end
def GA_address1; ''; end
def GA_city; ''; end
def GA_zip; ''; end
def GA_number_emp_transferred; ''; end
def GA_number_emp_retained; ''; end
def GA_est_mo_wages; ''; end
def GA_est_state_wh_tax; ''; end
def HI_pred_unemp_acct_number; ''; end
def HI_succ_unemp_acct_number; ''; end
def HI_pred_wh_acct_number; ''; end
def HI_address1; ''; end
def HI_city; ''; end
def HI_zip; ''; end
def HI_number_emp_transferred; ''; end
def HI_number_emp_retained; ''; end
def HI_est_mo_wages; ''; end
def HI_est_state_wh_tax; ''; end
def IA_pred_unemp_acct_number; ''; end
def IA_succ_unemp_acct_number; ''; end
def IA_pred_wh_acct_number; ''; end
def IA_address1; ''; end
def IA_city; ''; end
def IA_zip; ''; end
def IA_number_emp_transferred; ''; end
def IA_number_emp_retained; ''; end
def IA_est_mo_wages; ''; end
def IA_est_state_wh_tax; ''; end
def ID_pred_unemp_acct_number; ''; end
def ID_succ_unemp_acct_number; ''; end
def ID_pred_wh_acct_number; ''; end
def ID_address1; ''; end
def ID_city; ''; end
def ID_zip; ''; end
def ID_number_emp_transferred; ''; end
def ID_number_emp_retained; ''; end
def ID_est_mo_wages; ''; end
def ID_est_state_wh_tax; ''; end
def IL_pred_unemp_acct_number; ''; end
def IL_succ_unemp_acct_number; ''; end
def IL_pred_wh_acct_number; ''; end
def IL_address1; ''; end
def IL_city; ''; end
def IL_zip; ''; end
def IL_number_emp_transferred; ''; end
def IL_number_emp_retained; ''; end
def IL_est_mo_wages; ''; end
def IL_est_state_wh_tax; ''; end
def IN_pred_unemp_acct_number; ''; end
def IN_succ_unemp_acct_number; ''; end
def IN_pred_wh_acct_number; ''; end
def IN_address1; ''; end
def IN_city; ''; end
def IN_zip; ''; end
def IN_number_emp_transferred; ''; end
def IN_number_emp_retained; ''; end
def IN_est_mo_wages; ''; end
def IN_est_state_wh_tax; ''; end
def KS_pred_unemp_acct_number; ''; end
def KS_succ_unemp_acct_number; ''; end
def KS_pred_wh_acct_number; ''; end
def KS_address1; ''; end
def KS_city; ''; end
def KS_zip; ''; end
def KS_number_emp_transferred; ''; end
def KS_number_emp_retained; ''; end
def KS_est_mo_wages; ''; end
def KS_est_state_wh_tax; ''; end
def KY_pred_unemp_acct_number; ''; end
def KY_succ_unemp_acct_number; ''; end
def KY_pred_wh_acct_number; ''; end
def KY_address1; ''; end
def KY_city; ''; end
def KY_zip; ''; end
def KY_number_emp_transferred; ''; end
def KY_number_emp_retained; ''; end
def KY_est_mo_wages; ''; end
def KY_est_state_wh_tax; ''; end
def LA_pred_unemp_acct_number; ''; end
def LA_succ_unemp_acct_number; ''; end
def LA_pred_wh_acct_number; ''; end
def LA_address1; ''; end
def LA_city; ''; end
def LA_zip; ''; end
def LA_number_emp_transferred; ''; end
def LA_number_emp_retained; ''; end
def LA_est_mo_wages; ''; end
def LA_est_state_wh_tax; ''; end
def MA_pred_unemp_acct_number; ''; end
def MA_succ_unemp_acct_number; ''; end
def MA_pred_wh_acct_number; ''; end
def MA_address1; ''; end
def MA_city; ''; end
def MA_zip; ''; end
def MA_number_emp_transferred; ''; end
def MA_number_emp_retained; ''; end
def MA_est_mo_wages; ''; end
def MA_est_state_wh_tax; ''; end
def MD_pred_unemp_acct_number; ''; end
def MD_succ_unemp_acct_number; ''; end
def MD_pred_wh_acct_number; ''; end
def MD_address1; ''; end
def MD_city; ''; end
def MD_zip; ''; end
def MD_number_emp_transferred; ''; end
def MD_number_emp_retained; ''; end
def MD_est_mo_wages; ''; end
def MD_est_state_wh_tax; ''; end
def ME_pred_unemp_acct_number; ''; end
def ME_succ_unemp_acct_number; ''; end
def ME_pred_wh_acct_number; ''; end
def ME_address1; ''; end
def ME_city; ''; end
def ME_zip; ''; end
def ME_number_emp_transferred; ''; end
def ME_number_emp_retained; ''; end
def ME_est_mo_wages; ''; end
def ME_est_state_wh_tax; ''; end
def MI_pred_unemp_acct_number; ''; end
def MI_succ_unemp_acct_number; ''; end
def MI_pred_wh_acct_number; ''; end
def MI_address1; ''; end
def MI_city; ''; end
def MI_zip; ''; end
def MI_number_emp_transferred; ''; end
def MI_number_emp_retained; ''; end
def MI_est_mo_wages; ''; end
def MI_est_state_wh_tax; ''; end
def MN_pred_unemp_acct_number; ''; end
def MN_succ_unemp_acct_number; ''; end
def MN_pred_wh_acct_number; ''; end
def MN_address1; ''; end
def MN_city; ''; end
def MN_zip; ''; end
def MN_number_emp_transferred; ''; end
def MN_number_emp_retained; ''; end
def MN_est_mo_wages; ''; end
def MN_est_state_wh_tax; ''; end
def MO_pred_unemp_acct_number; ''; end
def MO_succ_unemp_acct_number; ''; end
def MO_pred_wh_acct_number; ''; end
def MO_address1; ''; end
def MO_city; ''; end
def MO_zip; ''; end
def MO_number_emp_transferred; ''; end
def MO_number_emp_retained; ''; end
def MO_est_mo_wages; ''; end
def MO_est_state_wh_tax; ''; end
def MS_pred_unemp_acct_number; ''; end
def MS_succ_unemp_acct_number; ''; end
def MS_pred_wh_acct_number; ''; end
def MS_address1; ''; end
def MS_city; ''; end
def MS_zip; ''; end
def MS_number_emp_transferred; ''; end
def MS_number_emp_retained; ''; end
def MS_est_mo_wages; ''; end
def MS_est_state_wh_tax; ''; end
def MT_pred_unemp_acct_number; ''; end
def MT_succ_unemp_acct_number; ''; end
def MT_pred_wh_acct_number; ''; end
def MT_address1; ''; end
def MT_city; ''; end
def MT_zip; ''; end
def MT_number_emp_transferred; ''; end
def MT_number_emp_retained; ''; end
def MT_est_mo_wages; ''; end
def MT_est_state_wh_tax; ''; end
def NC_pred_unemp_acct_number; ''; end
def NC_succ_unemp_acct_number; ''; end
def NC_pred_wh_acct_number; ''; end
def NC_address1; ''; end
def NC_city; ''; end
def NC_zip; ''; end
def NC_number_emp_transferred; ''; end
def NC_number_emp_retained; ''; end
def NC_est_mo_wages; ''; end
def NC_est_state_wh_tax; ''; end
def ND_pred_unemp_acct_number; ''; end
def ND_succ_unemp_acct_number; ''; end
def ND_pred_wh_acct_number; ''; end
def ND_address1; ''; end
def ND_city; ''; end
def ND_zip; ''; end
def ND_number_emp_transferred; ''; end
def ND_number_emp_retained; ''; end
def ND_est_mo_wages; ''; end
def ND_est_state_wh_tax; ''; end
def NE_pred_unemp_acct_number; ''; end
def NE_succ_unemp_acct_number; ''; end
def NE_pred_wh_acct_number; ''; end
def NE_address1; ''; end
def NE_city; ''; end
def NE_zip; ''; end
def NE_number_emp_transferred; ''; end
def NE_number_emp_retained; ''; end
def NE_est_mo_wages; ''; end
def NE_est_state_wh_tax; ''; end
def NH_pred_unemp_acct_number; ''; end
def NH_succ_unemp_acct_number; ''; end
def NH_pred_wh_acct_number; ''; end
def NH_address1; ''; end
def NH_city; ''; end
def NH_zip; ''; end
def NH_number_emp_transferred; ''; end
def NH_number_emp_retained; ''; end
def NH_est_mo_wages; ''; end
def NH_est_state_wh_tax; ''; end
def NJ_pred_unemp_acct_number; ''; end
def NJ_succ_unemp_acct_number; ''; end
def NJ_pred_wh_acct_number; ''; end
def NJ_address1; ''; end
def NJ_city; ''; end
def NJ_zip; ''; end
def NJ_number_emp_transferred; ''; end
def NJ_number_emp_retained; ''; end
def NJ_est_mo_wages; ''; end
def NJ_est_state_wh_tax; ''; end
def NM_pred_unemp_acct_number; ''; end
def NM_succ_unemp_acct_number; ''; end
def NM_pred_wh_acct_number; ''; end
def NM_address1; ''; end
def NM_city; ''; end
def NM_zip; ''; end
def NM_number_emp_transferred; ''; end
def NM_number_emp_retained; ''; end
def NM_est_mo_wages; ''; end
def NM_est_state_wh_tax; ''; end
def NV_pred_unemp_acct_number; ''; end
def NV_succ_unemp_acct_number; ''; end
def NV_pred_wh_acct_number; ''; end
def NV_address1; ''; end
def NV_city; ''; end
def NV_zip; ''; end
def NV_number_emp_transferred; ''; end
def NV_number_emp_retained; ''; end
def NV_est_mo_wages; ''; end
def NV_est_state_wh_tax; ''; end
def NY_pred_unemp_acct_number; ''; end
def NY_succ_unemp_acct_number; ''; end
def NY_pred_wh_acct_number; ''; end
def NY_address1; ''; end
def NY_city; ''; end
def NY_zip; ''; end
def NY_number_emp_transferred; ''; end
def NY_number_emp_retained; ''; end
def NY_est_mo_wages; ''; end
def NY_est_state_wh_tax; ''; end
def OH_pred_unemp_acct_number; ''; end
def OH_succ_unemp_acct_number; ''; end
def OH_pred_wh_acct_number; ''; end
def OH_address1; ''; end
def OH_city; ''; end
def OH_zip; ''; end
def OH_number_emp_transferred; ''; end
def OH_number_emp_retained; ''; end
def OH_est_mo_wages; ''; end
def OH_est_state_wh_tax; ''; end
def OK_pred_unemp_acct_number; ''; end
def OK_succ_unemp_acct_number; ''; end
def OK_pred_wh_acct_number; ''; end
def OK_address1; ''; end
def OK_city; ''; end
def OK_zip; ''; end
def OK_number_emp_transferred; ''; end
def OK_number_emp_retained; ''; end
def OK_est_mo_wages; ''; end
def OK_est_state_wh_tax; ''; end
def OR_pred_unemp_acct_number; ''; end
def OR_succ_unemp_acct_number; ''; end
def OR_pred_wh_acct_number; ''; end
def OR_address1; ''; end
def OR_city; ''; end
def OR_zip; ''; end
def OR_number_emp_transferred; ''; end
def OR_number_emp_retained; ''; end
def OR_est_mo_wages; ''; end
def OR_est_state_wh_tax; ''; end
def PA_pred_unemp_acct_number; ''; end
def PA_succ_unemp_acct_number; ''; end
def PA_pred_wh_acct_number; ''; end
def PA_address1; ''; end
def PA_city; ''; end
def PA_zip; ''; end
def PA_number_emp_transferred; ''; end
def PA_number_emp_retained; ''; end
def PA_est_mo_wages; ''; end
def PA_est_state_wh_tax; ''; end
def PR_pred_unemp_acct_number; ''; end
def PR_succ_unemp_acct_number; ''; end
def PR_pred_wh_acct_number; ''; end
def PR_address1; ''; end
def PR_city; ''; end
def PR_zip; ''; end
def PR_number_emp_transferred; ''; end
def PR_number_emp_retained; ''; end
def PR_est_mo_wages; ''; end
def PR_est_state_wh_tax; ''; end
def RI_pred_unemp_acct_number; ''; end
def RI_succ_unemp_acct_number; ''; end
def RI_pred_wh_acct_number; ''; end
def RI_address1; ''; end
def RI_city; ''; end
def RI_zip; ''; end
def RI_number_emp_transferred; ''; end
def RI_number_emp_retained; ''; end
def RI_est_mo_wages; ''; end
def RI_est_state_wh_tax; ''; end
def SC_pred_unemp_acct_number; ''; end
def SC_succ_unemp_acct_number; ''; end
def SC_pred_wh_acct_number; ''; end
def SC_address1; ''; end
def SC_city; ''; end
def SC_zip; ''; end
def SC_number_emp_transferred; ''; end
def SC_number_emp_retained; ''; end
def SC_est_mo_wages; ''; end
def SC_est_state_wh_tax; ''; end
def SD_pred_unemp_acct_number; ''; end
def SD_succ_unemp_acct_number; ''; end
def SD_pred_wh_acct_number; ''; end
def SD_address1; ''; end
def SD_city; ''; end
def SD_zip; ''; end
def SD_number_emp_transferred; ''; end
def SD_number_emp_retained; ''; end
def SD_est_mo_wages; ''; end
def SD_est_state_wh_tax; ''; end
def TN_pred_unemp_acct_number; ''; end
def TN_succ_unemp_acct_number; ''; end
def TN_pred_wh_acct_number; ''; end
def TN_address1; ''; end
def TN_city; ''; end
def TN_zip; ''; end
def TN_number_emp_transferred; ''; end
def TN_number_emp_retained; ''; end
def TN_est_mo_wages; ''; end
def TN_est_state_wh_tax; ''; end
def TX_pred_unemp_acct_number; ''; end
def TX_succ_unemp_acct_number; ''; end
def TX_pred_wh_acct_number; ''; end
def TX_address1; ''; end
def TX_city; ''; end
def TX_zip; ''; end
def TX_number_emp_transferred; ''; end
def TX_number_emp_retained; ''; end
def TX_est_mo_wages; ''; end
def TX_est_state_wh_tax; ''; end
def UT_pred_unemp_acct_number; ''; end
def UT_succ_unemp_acct_number; ''; end
def UT_pred_wh_acct_number; ''; end
def UT_address1; ''; end
def UT_city; ''; end
def UT_zip; ''; end
def UT_number_emp_transferred; ''; end
def UT_number_emp_retained; ''; end
def UT_est_mo_wages; ''; end
def UT_est_state_wh_tax; ''; end
def VA_pred_unemp_acct_number; ''; end
def VA_succ_unemp_acct_number; ''; end
def VA_pred_wh_acct_number; ''; end
def VA_address1; ''; end
def VA_city; ''; end
def VA_zip; ''; end
def VA_number_emp_transferred; ''; end
def VA_number_emp_retained; ''; end
def VA_est_mo_wages; ''; end
def VA_est_state_wh_tax; ''; end
def VI_pred_unemp_acct_number; ''; end
def VI_succ_unemp_acct_number; ''; end
def VI_pred_wh_acct_number; ''; end
def VI_address1; ''; end
def VI_city; ''; end
def VI_zip; ''; end
def VI_number_emp_transferred; ''; end
def VI_number_emp_retained; ''; end
def VI_est_mo_wages; ''; end
def VI_est_state_wh_tax; ''; end
def VT_pred_unemp_acct_number; ''; end
def VT_succ_unemp_acct_number; ''; end
def VT_pred_wh_acct_number; ''; end
def VT_address1; ''; end
def VT_city; ''; end
def VT_zip; ''; end
def VT_number_emp_transferred; ''; end
def VT_number_emp_retained; ''; end
def VT_est_mo_wages; ''; end
def VT_est_state_wh_tax; ''; end
def WA_pred_unemp_acct_number; ''; end
def WA_succ_unemp_acct_number; ''; end
def WA_pred_wh_acct_number; ''; end
def WA_address1; ''; end
def WA_city; ''; end
def WA_zip; ''; end
def WA_number_emp_transferred; ''; end
def WA_number_emp_retained; ''; end
def WA_est_mo_wages; ''; end
def WA_est_state_wh_tax; ''; end
def WI_pred_unemp_acct_number; ''; end
def WI_succ_unemp_acct_number; ''; end
def WI_pred_wh_acct_number; ''; end
def WI_address1; ''; end
def WI_city; ''; end
def WI_zip; ''; end
def WI_number_emp_transferred; ''; end
def WI_number_emp_retained; ''; end
def WI_est_mo_wages; ''; end
def WI_est_state_wh_tax; ''; end
def WV_pred_unemp_acct_number; ''; end
def WV_succ_unemp_acct_number; ''; end
def WV_pred_wh_acct_number; ''; end
def WV_address1; ''; end
def WV_city; ''; end
def WV_zip; ''; end
def WV_number_emp_transferred; ''; end
def WV_number_emp_retained; ''; end
def WV_est_mo_wages; ''; end
def WV_est_state_wh_tax; ''; end
def WY_pred_unemp_acct_number; ''; end
def WY_succ_unemp_acct_number; ''; end
def WY_pred_wh_acct_number; ''; end
def WY_address1; ''; end
def WY_city; ''; end
def WY_zip; ''; end
def WY_number_emp_transferred; ''; end
def WY_number_emp_retained; ''; end
def WY_est_mo_wages; ''; end
def WY_est_state_wh_tax; ''; end
end

class Fcc
 def applicant_middle_initial; ''; end
 def applicant_suffix; ''; end
 def applicant_address; ''; end
 def applicant_po_box; ''; end
 def applicant_city; ''; end
 def applicant_state; ''; end
 def applicant_zip; ''; end
 def applicant_country; ''; end
 def applicant_frn; ''; end
 def applicant_phone; ''; end
 def applicant_fax; ''; end
 def applicant_email; ''; end
 def contact_first_name; ''; end
 def contact_middle_initial; ''; end
 def contact_last_name; ''; end
 def contact_suffix; ''; end
 def contact_entity_name; ''; end
 def contact_address; ''; end
 def contact_po_box; ''; end
 def contact_city; ''; end
 def contact_state; ''; end
 def contact_zip; ''; end
 def contact_phone; ''; end
 def contact_fax; ''; end
 def contact_email; ''; end
 def signatory_first_name; ''; end
 def signatory_middle_initial; ''; end
 def signatory_last_name; ''; end
 def signatory_suffix; ''; end
 def signatory_title; ''; end
 def applicant_first_name; ''; end
 def applicant_last_name; ''; end
 def applicant_entity_name; ''; end
end

# ***** Field Data *****
box3_1 = ''
box3_2 = ''
box3_3 = ''
box3_4 = ''
box3_5 = ''
box3_6 = ''
box3_7 = ''
box3_8 = ''
box3_9 = ''
box3_10 = ''
box3_11 = ''
box8_1 = ''
box8_2 = ''
box8_3 = ''
box9_1 = ''
box9_2 = ''
box9_3 = ''
box9_4 = ''
box9_5 = ''
box9_6 = ''
box9_7 = ''
box9_8 = ''
box11_1 = ''
box11_2 = ''
box11_3 = ''
box11_4 = ''
box12_1 = ''
box12_2 = ''
box12_3 = ''
box12_4 = ''
box12_5 = ''
box12_6 = ''
box12_7 = ''
box12_8 = ''
box12_9 = ''
box12_10 = ''
box12_11 = ''
box12_12 = ''
box12_13 = ''
box12_14 = ''
box12_15 = ''
box12_16 = ''
box18_1 = ''
box18_2 = ''
box18_3 = ''
box18_4 = ''
box18_5 = ''
box18_6 = ''
box18_7 = ''
box18_10 = ''
box18_8 = ''
box18_9 = ''
box26_1 = ''
box26_2 = ''
box26_3 = ''
box26_4 = ''
box26_5 = ''
box26_6 = ''
box26_7 = ''
box26_10 = ''
box26_8 = ''
box26_9 = ''

# ***** Calculations *****

$,="\x02"
$\="\x03\n"

#
# No DataFlow
#
# Note 08/28/14:The earlier notes below have been verified and are still applicable, any changes
# or updates will be indicated with a new note.
#
# 09/04/08 NOTE: Rounding was being employed in this form due to it being mentioned on Page 8
# under "Line Instructions", however, it has been determined that rounding actually pertains to 
# the associated form that these instructions go with. So in a nutshell, we are now using $CUR.
#

# Line 2 
if (box8_1 + box8_2).strip.length > 0
	box8_3 = $CUR % (box8_1.to_f - box8_2.to_f)
else
	box8_3 = ''
end
print 'box8_3', box8_3

#Worksheet for Line 10
if ((box9_1 + box9_2 + box9_4 + box9_7).strip.length > 0)

	box9_3 = $CUR % (box9_1.to_f - box9_2.to_f)
	box9_5 = $CUR % (box9_1.to_f + box9_4.to_f)
	#Note 03/03/14:The line instruction says:"enter the resulting decimal".
	box9_6 = '%0.6f' % (box9_5.to_f > 0.0 ? box9_3.to_f / box9_5.to_f : 0)
	box9_8 = $CUR % (box9_7.to_f * box9_6.to_f)
else
	box9_3 = ''
	box9_5 = ''
	box9_6 = ''
	box9_8 = ''
end

print 'box9_3', box9_3
print 'box9_5', box9_5
print 'box9_6', box9_6
print 'box9_8', box9_8

#Line 33 for Retirement Account Subtraction

if ((box11_2 + box11_3).strip.length > 0)

	box11_4 = $CUR % [box11_2.to_f, box11_3.to_f].min
else
	box11_4 = ''
end

print 'box11_4', box11_4

# Worksheet 1
if (box12_1 + box12_2).strip.length > 0
	box12_3 = $CUR % (box12_1.to_f + box12_2.to_f)
else
	box12_3 = ''
end
print 'box12_3', box12_3

# Worksheet 2
if (box12_4 + box12_5).strip.length > 0
	box12_6 = $CUR % (box12_4.to_f * box12_5.to_f / 100.0)
else
	box12_6 = ''
end
print 'box12_6', box12_6

# Worksheet 3
if (box12_7 + box12_8).strip.length > 0
	# Round to the nearest whole percentage per instructions.
	box12_9 = '%0.0f' % (box12_8.to_f > 0.0 ? box12_7.to_f / box12_8.to_f * 100.0 : 0)
else
	box12_9 = ''
end
print 'box12_9', box12_9

#Worksheet 4 

box12_14 = ''

if ((box12_10 + box12_11 + box12_12 + box12_15).strip.length > 0)

	box12_13 = $CUR % (box12_11.to_f.abs + box12_12.to_f.abs)

	if (box12_10.to_f > 0.0)
		box12_16 = box12_13
	else
		box12_14 = $CUR % (box12_10.to_f + box12_13.to_f)
		box12_16 = $CUR % [box12_14.to_f + box12_15.to_f.abs, 0.0].max
	end
else
	box12_13 = ''
	box12_16 = ''
end

print 'box12_13', box12_13
print 'box12_14', box12_14
print 'box12_16', box12_16

#
#-#################################################################
#
# Renter's Worksheet:
#
# 04/21/17 [htruax]: Removed use of parallel assignment to step3, step6, step9.
box18_3 = ''
box18_4 = ''
box18_5 = ''
box18_6 = ''
box18_7 = ''
box18_8 = ''
box18_9 = ''
box18_10 = ''

if ((box18_1 + box18_2).strip.length > 0)

	if (box18_2.to_f < 22870.0)
		step3 = ''
		step6 = ''
		step9 = ''
	else
		case (box18_2.to_f)
		
			when (22870.0...24500.0)
				step3 = 0.017
				step6 = 0.75
				step9 = 1749

			when (24500.0...27780.0)
				step3 = 0.018
				step6 = 0.75
				step9 = 1749

			when (27780.0...29400.0)
				step3 = 0.019
				step6 = 0.70
				step9 = 1749

			when (29400.0...34300.0)
				step3 = 0.020
				step6 = 0.70
				step9 = 1749

			when (34300.0...39200.0)
				step3 = 0.020
				step6 = 0.65
				step9 = 1749

			when (39200.0...45740.0)
				step3 = 0.020
				step6 = 0.60
				step9 = 1749

			when (45740.0...47370.0)
				step3 = 0.020
				step6 = 0.55
				step9 = 1590

			when (47370.0...49010.0)
				step3 = 0.020
				step6 = 0.55
				step9 = 1431

			when (49010.0...50650.0)
				step3 = 0.020
				step6 = 0.55
				step9 = 1219

			when (50650.0...52270.0)
				step3 = 0.020
				step6 = 0.50
				step9 = 1060

			when (52270.0...53910.0)
				step3 = 0.020
				step6 = 0.50
				step9 = 954

			when (53910.0...55540.0)
				step3 = 0.020
				step6 = 0.50
				step9 = 530

			when (55540.0...57170.0)
				step3 = 0.020
				step6 = 0.50
				step9 = 212

			else
				step3 = "not eligible"
				step6 = "not eligible"
				step9 = "not eligible"
		end
	end

	box18_3 = step3
	box18_4 = $CUR % (box18_2.to_f * box18_3.to_f)
	box18_5 = $CUR % (box18_1.to_f - box18_4.to_f)
	
	if (box18_5.to_f > 0.0)

		box18_6 = step6
		box18_7 = $CUR % (box18_5.to_f * box18_6.to_f)
		box18_10 = $CUR % (box18_7.to_f * 1.06)

		#
		# Formatting step9 so it matches the rest of the money amounts.
		#
		box18_8 = (step9.to_f > 0.0 ? $CUR % (step9.to_f) : step9)

		box18_9 = $CUR % [box18_10.to_f, box18_8.to_f].min
	end
end

print 'box18_3', box18_3
print 'box18_4', box18_4
print 'box18_5', box18_5
print 'box18_6', box18_6
print 'box18_7', box18_7
print 'box18_8', box18_8
print 'box18_9', box18_9
print 'box18_10', box18_10

#
#-#################################################################
#
# Homowners Only - Violators will be shot:
#
# 04/21/17 [htruax]: Removed use of parallel assignment to step3, step6, step9.
#
box26_3 = ''
box26_4 = ''
box26_5 = ''
box26_6 = ''
box26_7 = ''
box26_8 = ''
box26_9 = ''
box26_10 = ''

if ((box26_1 + box26_2).strip.length > 0)

	if (box26_2.to_f < 14650.0)
		step3 = ''
		step6 = ''
		step9 = ''
	else
		case (box26_2.to_f)

			when (14650.0...16270.0)
				step3 = 0.018
				step6 = 0.80
				step9 = 2657

			when (16270.0...17880.0)
				step3 = 0.019
				step6 = 0.75
				step9 = 2657

			when (17880.0...22780.0)
				step3 = 0.020
				step6 = 0.75
				step9 = 2657

			when (22780.0...27660.0)
				step3 = 0.020
				step6 = 0.70
				step9 = 2657

			when (27660.0...39030.0)
				step3 = 0.020
				step6 = 0.65
				step9 = 2657

			when (39030.0...56920.0)
				step3 = 0.020
				step6 = 0.65
				step9 = 2153

			when (56920.0...65050.0)
				step3 = 0.020
				step6 = 0.60
				step9 = 1885

			when (65050.0...73190.0)
				step3 = 0.021
				step6 = 0.60
				step9 = 1555

			when (73190.0...81320.0)
				step3 = 0.022
				step6 = 0.60
				step9 = 1391

			when (81320.0...89450.0)
				step3 = 0.023
				step6 = 0.60
				step9 = 1215

			when (89450.0...94340.0)
				step3 = 0.024
				step6 = 0.55
				step9 = 1030

			when (94340.0...97610.0)
				step3 = 0.025
				step6 = 0.55
				step9 = 855

			when (97610.0...101560.0)
				step3 = 0.025
				step6 = 0.50
				step9 = 700

			when (101560.0...105500.0)
				step3 = 0.025
				step6 = 0.50
				step9 = 515

			else
				step3 = "not eligible"
				step6 = "not eligible"
				step9 = "not eligible"
		end
	end

	box26_3 = step3
	box26_4 = $CUR % (box26_2.to_f * box26_3.to_f)
	box26_5 = $CUR % (box26_1.to_f - box26_4.to_f)
	
	if (box26_5.to_f > 0.0)

		box26_6 = step6
		box26_7 = $CUR % (box26_5.to_f * box26_6.to_f)
		box26_10 = $CUR % (box26_7.to_f * 1.03)

		#
		# Formatting step9 so it matches the rest of the money amounts.
		#
		box26_8 = (step9.to_f > 0.0 ? $CUR % (step9.to_f) : step9)

		box26_9 = $CUR % [box26_10.to_f, box26_8.to_f].min
	end
end
print 'box26_3', box26_3
print 'box26_4', box26_4
print 'box26_5', box26_5
print 'box26_6', box26_6
print 'box26_7', box26_7
print 'box26_8', box26_8
print 'box26_9', box26_9
print 'box26_10', box26_10
